comonad-5: Comonads

Copyright | (C) 2008-2012 Edward Kmett
License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | experimental
Portability | non-portable (fundeps, MPTCs)
Safe Haskell | Safe
Language | Haskell2010

Control.Comonad.Traced.Class

Description

# Documentation

class Comonad w => ComonadTraced m w | w -> m where #

Minimal complete definition

trace

Methods

trace :: m -> w a -> a #

Instances

Monoid m => ComonadTraced m ((->) m) # |
Methods trace :: m -> (m -> a) -> a #
ComonadTraced m w => ComonadTraced m (StoreT s w) # |
Methods trace :: m -> StoreT s w a -> a #
ComonadTraced m w => ComonadTraced m (EnvT e w) # |
Methods trace :: m -> EnvT e w a -> a #
ComonadTraced m w => ComonadTraced m (IdentityT * w) # |
Methods trace :: m -> IdentityT * w a -> a #
(Comonad w, Monoid m) => ComonadTraced m (TracedT m w) # |
Methods trace :: m -> TracedT m w a -> a #

traces :: ComonadTraced m w => (a -> m) -> w a -> a #